<script lang="ts">
  import { afterUpdate, onMount } from 'svelte';
  import Checkmark from './states/Checkmark.svelte';
  import Cross from './states/Cross.svelte';

  let wrapper: HTMLDivElement;

  export let completed: boolean;
  let checkmark = false;
  let cross = false;

  const restartAnimation = () => {
    // -> removing the class
    wrapper.classList.remove('loader-wrapper');

    // -> triggering reflow /* The actual magic */
    // without this it wouldn't work. Try uncommenting the line and the transition won't be retriggered.
    void wrapper.offsetWidth;

    // -> and re-adding the class
    wrapper.classList.add('loader-wrapper');
  };

  onMount(() => {
    const onAnimationEnd = () => {
      if (completed === true) {
        wrapper.classList.add('completed');
      } else if (completed === false) {
        wrapper.classList.add('failed');
      } else {
        restartAnimation();
      }
    };

    setTimeout(() => {
      completed = false;
    }, 1000);

    wrapper.addEventListener('animationend', onAnimationEnd);

    return () => wrapper.removeEventListener('animationend', onAnimationEnd);
  });

  afterUpdate(() => {
    // After each update, set the showCheckmark flag based on completed
    checkmark = completed === true;
    cross = completed === false;
  });
</script>

<div
  bind:this={wrapper}
  class="loader-wrapper {checkmark}">
  {#if checkmark}
    <Checkmark
      --size={'var(--circle-size)'}
      --color={'var(--checkmark-color)'}
      --stroke={'var(--border-width)'} />
  {:else if cross}
    <Cross
      --size={'var(--circle-size)'}
      --color={'var(--cross-color)'}
      --stroke={'var(--border-width)'} />
  {/if}
</div>

<style>
  :root {
    --circle-size: 100px;
    --border-width: 3px;
    --border-color: hsl(0deg 0% 97%);
    --progress-color: orange;
    --checkmark-color: hsl(172deg 76% 41%);
    --cross-color: hsl(0deg 76% 41%);
  }

  .loader-wrapper {
    position: relative;
    width: var(--circle-size);
    height: var(--circle-size);
    margin-right: auto;
    margin-left: auto;
  }

  .loader-wrapper::before {
    position: absolute;
    z-index: 1;
    display: block;
    width: 100%;
    height: 100%;
    border: var(--border-width) solid transparent;
    border-radius: 50%;
    border-left-color: var(--progress-color);
    animation: spin linear 0.85s;
    content: '';
    inset: 0;
  }

  .loader-wrapper::after {
    position: absolute;
    z-index: 0;
    display: block;
    width: 100%;
    height: 100%;
    border: var(--border-width) solid var(--border-color);
    border-color: var(--border-color);
    border-radius: 50%;
    content: '';
    inset: 0;
  }

  .loader-wrapper.completed::before,
  .loader-wrapper.failed::before {
    opacity: 0;
    transition: opacity 0.5s ease-out;
  }

  .loader-wrapper.completed::after {
    border-color: var(--checkmark-color);
    transition: border-color 0.5s ease-out;
  }

  .loader-wrapper.failed::after {
    border-color: var(--cross-color);
    transition: border-color 0.5s ease-out;
  }

  @keyframes spin {
    from {
      transform: rotate(0deg);
    }

    to {
      transform: rotate(360deg);
    }
  }
</style>
